diff --git a/tensorflow/python/ops/control_flow_grad.py b/tensorflow/python/ops/control_flow_grad.py
index 6a551deb5ba..a5f4848bf7d 100644
--- a/tensorflow/python/ops/control_flow_grad.py
+++ b/tensorflow/python/ops/control_flow_grad.py
@@ -18,7 +18,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import ops
@@ -131,10 +130,10 @@ def _MergeGrad(op, grad, _):
     # pylint: enable=protected-access
   else:
     num_inputs = len(op.inputs)
-    cond = [math_ops.equal(op.outputs[1], i) for i in xrange(num_inputs)]
+    cond = [math_ops.equal(op.outputs[1], i) for i in range(num_inputs)]
     # pylint: disable=protected-access
     return [control_flow_ops._SwitchRefOrTensor(grad, cond[i])[1]
-            for i in xrange(num_inputs)]
+            for i in range(num_inputs)]
     # pylint: enable=protected-access
 
 
diff --git a/tensorflow/python/ops/data_flow_grad.py b/tensorflow/python/ops/data_flow_grad.py
index 7e382af64f6..50edcd6fd4f 100644
--- a/tensorflow/python/ops/data_flow_grad.py
+++ b/tensorflow/python/ops/data_flow_grad.py
@@ -18,8 +18,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
-
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import ops
 from tensorflow.python.ops import array_ops
@@ -55,7 +53,7 @@ def _DynamicStitchGrads(op, grad):
   def AsInt32(x):
     return (x if op.inputs[0].dtype == dtypes.int32 else
             math_ops.cast(x, dtypes.int32))
-  inputs = [AsInt32(op.inputs[i]) for i in xrange(num_values)]
+  inputs = [AsInt32(op.inputs[i]) for i in range(num_values)]
   if isinstance(grad, ops.IndexedSlices):
     output_shape = array_ops.shape(op.outputs[0])
     output_rows = output_shape[0]
diff --git a/tensorflow/python/ops/embedding_ops.py b/tensorflow/python/ops/embedding_ops.py
index 9c437d32b9e..01f9a4352ce 100644
--- a/tensorflow/python/ops/embedding_ops.py
+++ b/tensorflow/python/ops/embedding_ops.py
@@ -17,8 +17,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
-
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import ops
@@ -158,14 +156,14 @@ def _embedding_lookup_and_transform(params,
         # if we already know the full shape statically.
         dim_0_size = tensor_shape.Dimension(
             tensor_shape.dimension_value(params[0].get_shape()[0]))
-        for p in xrange(1, np):
+        for p in range(1, np):
           dim_0_size += tensor_shape.Dimension(
               tensor_shape.dimension_value(params[p].get_shape()[0]))
         if dim_0_size.value:
           num_total_ids = constant_op.constant(dim_0_size.value, flat_ids.dtype)
         else:
           dim_0_sizes = []
-          for p in xrange(np):
+          for p in range(np):
             param_p_dim = tensor_shape.dimension_value(params[p].get_shape()[0])
             if param_p_dim is not None:
               dim_0_sizes.append(param_p_dim)
@@ -199,7 +197,7 @@ def _embedding_lookup_and_transform(params,
                                                  p_assignments, np)
       # Do np separate lookups, finding embeddings for plist[p] in params[p]
       partitioned_result = []
-      for p in xrange(np):
+      for p in range(np):
         pids = gather_ids[p]
         with ops.colocate_with(params[p]):
           result = array_ops.gather(params[p], pids)
diff --git a/tensorflow/python/ops/gradients_util.py b/tensorflow/python/ops/gradients_util.py
index 53520ec1075..0996fe47585 100644
--- a/tensorflow/python/ops/gradients_util.py
+++ b/tensorflow/python/ops/gradients_util.py
@@ -21,8 +21,6 @@ from __future__ import print_function
 import collections
 import contextlib
 
-from six.moves import xrange, zip  # pylint: disable=redefined-builtin
-
 from tensorflow.core.framework import attr_value_pb2
 from tensorflow.python.eager import backprop
 from tensorflow.python.eager import context
@@ -781,7 +779,7 @@ def _SetGrad(grads, t, grad):
   op = t.op
   op_grads = grads.get(op)
   if not op_grads:
-    op_grads = [[] for _ in xrange(len(op.outputs))]
+    op_grads = [[] for _ in range(len(op.outputs))]
     grads[op] = op_grads
   t_grads = op_grads[t.value_index]
   if isinstance(t_grads, list):
@@ -820,7 +818,7 @@ def _GetGrads(grads, op):
   if op in grads:
     return grads[op]
   else:
-    return [[] for _ in xrange(len(op.outputs))]
+    return [[] for _ in range(len(op.outputs))]
 
 
 def _AccumulatorShape(inputs):
diff --git a/tensorflow/python/ops/image_ops_test.py b/tensorflow/python/ops/image_ops_test.py
index 8dd6e35e7bf..66ea4996a63 100644
--- a/tensorflow/python/ops/image_ops_test.py
+++ b/tensorflow/python/ops/image_ops_test.py
@@ -26,7 +26,6 @@ import os
 import time
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.compat import compat
 from tensorflow.core.protobuf import config_pb2
@@ -159,9 +158,9 @@ class GrayscaleToRGBTest(test_util.TensorFlowTestCase):
       images = np.expand_dims(images, axis=0)
     out_shape = images.shape[0:3] + (1,)
     out = np.zeros(shape=out_shape, dtype=np.uint8)
-    for batch in xrange(images.shape[0]):
-      for y in xrange(images.shape[1]):
-        for x in xrange(images.shape[2]):
+    for batch in range(images.shape[0]):
+      for y in range(images.shape[1]):
+        for x in range(images.shape[2]):
           red = images[batch, y, x, 0]
           green = images[batch, y, x, 1]
           blue = images[batch, y, x, 2]
@@ -460,7 +459,7 @@ class AdjustHueTest(test_util.TensorFlowTestCase):
     x_v = x_np.reshape([-1, 3])
     y_v = np.ndarray(x_v.shape, dtype=x_v.dtype)
     channel_count = x_v.shape[0]
-    for i in xrange(channel_count):
+    for i in range(channel_count):
       r = x_v[i][0]
       g = x_v[i][1]
       b = x_v[i][2]
@@ -551,7 +550,7 @@ class FlipImageBenchmark(test.Benchmark):
             dtype=dtypes.float32)
         run_op = image_ops.flip_left_right(inputs)
         self.evaluate(variables.global_variables_initializer())
-        for i in xrange(warmup_rounds + benchmark_rounds):
+        for i in range(warmup_rounds + benchmark_rounds):
           if i == warmup_rounds:
             start = time.time()
           self.evaluate(run_op)
@@ -581,7 +580,7 @@ class FlipImageBenchmark(test.Benchmark):
             dtype=dtypes.float32)
         run_op = image_ops.random_flip_left_right(inputs)
         self.evaluate(variables.global_variables_initializer())
-        for i in xrange(warmup_rounds + benchmark_rounds):
+        for i in range(warmup_rounds + benchmark_rounds):
           if i == warmup_rounds:
             start = time.time()
           self.evaluate(run_op)
@@ -611,7 +610,7 @@ class FlipImageBenchmark(test.Benchmark):
             dtype=dtypes.float32)
         run_op = image_ops.random_flip_left_right(inputs)
         self.evaluate(variables.global_variables_initializer())
-        for i in xrange(warmup_rounds + benchmark_rounds):
+        for i in range(warmup_rounds + benchmark_rounds):
           if i == warmup_rounds:
             start = time.time()
           self.evaluate(run_op)
@@ -673,7 +672,7 @@ class AdjustHueBenchmark(test.Benchmark):
       outputs = image_ops.adjust_hue(inputs, delta)
       run_op = control_flow_ops.group(outputs)
       self.evaluate(variables.global_variables_initializer())
-      for i in xrange(warmup_rounds + benchmark_rounds):
+      for i in range(warmup_rounds + benchmark_rounds):
         if i == warmup_rounds:
           start = time.time()
         self.evaluate(run_op)
@@ -716,10 +715,10 @@ class AdjustSaturationBenchmark(test.Benchmark):
       outputs = image_ops.adjust_saturation(inputs, delta)
       run_op = control_flow_ops.group(outputs)
       self.evaluate(variables.global_variables_initializer())
-      for _ in xrange(warmup_rounds):
+      for _ in range(warmup_rounds):
         self.evaluate(run_op)
       start = time.time()
-      for _ in xrange(benchmark_rounds):
+      for _ in range(benchmark_rounds):
         self.evaluate(run_op)
     end = time.time()
     step_time = (end - start) / benchmark_rounds
@@ -752,7 +751,7 @@ class ResizeBilinearBenchmark(test.Benchmark):
         name="img")
 
     deps = []
-    for _ in xrange(num_ops):
+    for _ in range(num_ops):
       with ops.control_dependencies(deps):
         resize_op = image_ops.resize_bilinear(
             img, [299, 299], align_corners=False)
@@ -800,7 +799,7 @@ class ResizeBicubicBenchmark(test.Benchmark):
         name="img")
 
     deps = []
-    for _ in xrange(num_ops):
+    for _ in range(num_ops):
       with ops.control_dependencies(deps):
         resize_op = image_ops.resize_bicubic(
             img, [299, 299], align_corners=False)
@@ -858,7 +857,7 @@ class ResizeAreaBenchmark(test.Benchmark):
         name="img")
 
     deps = []
-    for _ in xrange(num_ops):
+    for _ in range(num_ops):
       with ops.control_dependencies(deps):
         resize_op = image_ops.resize_area(img, [299, 299], align_corners=False)
         deps = [resize_op]
@@ -946,7 +945,7 @@ class AdjustSaturationTest(test_util.TensorFlowTestCase):
     x_v = x_np.reshape([-1, 3])
     y_v = np.ndarray(x_v.shape, dtype=x_v.dtype)
     channel_count = x_v.shape[0]
-    for i in xrange(channel_count):
+    for i in range(channel_count):
       r = x_v[i][0]
       g = x_v[i][1]
       b = x_v[i][2]
@@ -1332,7 +1331,7 @@ class FlipTransposeRotateTest(test_util.TensorFlowTestCase):
     image = np.arange(24, dtype=np.uint8).reshape([2, 4, 3])
     with self.cached_session(use_gpu=True):
       rotated = image
-      for _ in xrange(4):
+      for _ in range(4):
         rotated = image_ops.rot90(rotated)
       self.assertAllEqual(image, self.evaluate(rotated))
 
@@ -1340,7 +1339,7 @@ class FlipTransposeRotateTest(test_util.TensorFlowTestCase):
     image = np.arange(48, dtype=np.uint8).reshape([2, 2, 4, 3])
     with self.cached_session(use_gpu=True):
       rotated = image
-      for _ in xrange(4):
+      for _ in range(4):
         rotated = image_ops.rot90(rotated)
       self.assertAllEqual(image, self.evaluate(rotated))
 
@@ -1350,7 +1349,7 @@ class FlipTransposeRotateTest(test_util.TensorFlowTestCase):
     with self.cached_session(use_gpu=True):
       k_placeholder = array_ops.placeholder(dtypes.int32, shape=[])
       y_tf = image_ops.rot90(image, k_placeholder)
-      for k in xrange(4):
+      for k in range(4):
         y_np = np.rot90(image, k=k)
         self.assertAllEqual(y_np, y_tf.eval({k_placeholder: k}))
 
@@ -1360,7 +1359,7 @@ class FlipTransposeRotateTest(test_util.TensorFlowTestCase):
     with self.cached_session(use_gpu=True):
       k_placeholder = array_ops.placeholder(dtypes.int32, shape=[])
       y_tf = image_ops.rot90(image, k_placeholder)
-      for k in xrange(4):
+      for k in range(4):
         y_np = np.rot90(image, k=k, axes=(1, 2))
         self.assertAllEqual(y_np, y_tf.eval({k_placeholder: k}))
 
@@ -2114,7 +2113,7 @@ class SelectDistortedCropBoxTest(test_util.TensorFlowTestCase):
           area_range=area_range)
       y = array_ops.strided_slice(image_tf, begin, begin + size)
 
-      for _ in xrange(num_iter):
+      for _ in range(num_iter):
         y_tf = self.evaluate(y)
         crop_height = y_tf.shape[0]
         crop_width = y_tf.shape[1]
@@ -2135,7 +2134,7 @@ class SelectDistortedCropBoxTest(test_util.TensorFlowTestCase):
           area_range=area_range)
       y = array_ops.strided_slice(image_tf, begin, begin + size)
 
-      for _ in xrange(num_iter):
+      for _ in range(num_iter):
         y_tf = y.eval(feed_dict={
             min_object_covered_placeholder: min_object_covered
         })
diff --git a/tensorflow/python/ops/math_ops.py b/tensorflow/python/ops/math_ops.py
index e849a687de8..ba07e6b5aa7 100644
--- a/tensorflow/python/ops/math_ops.py
+++ b/tensorflow/python/ops/math_ops.py
@@ -71,7 +71,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.compat import compat as fwd_compat
 from tensorflow.python.eager import context
@@ -3988,7 +3987,7 @@ def tensordot(a, b, axes, name=None):
     if a.get_shape().is_fully_defined() and isinstance(axes, (list, tuple)):
       shape_a = a.get_shape().as_list()
       axes = [i if i >= 0 else i + len(shape_a) for i in axes]
-      free = [i for i in xrange(len(shape_a)) if i not in axes]
+      free = [i for i in range(len(shape_a)) if i not in axes]
       free_dims = [shape_a[i] for i in free]
       prod_free = int(np.prod([shape_a[i] for i in free]))
       prod_axes = int(np.prod([shape_a[i] for i in axes]))
@@ -4000,7 +3999,7 @@ def tensordot(a, b, axes, name=None):
       if a.get_shape().ndims is not None and isinstance(axes, (list, tuple)):
         shape_a = a.get_shape().as_list()
         axes = [i if i >= 0 else i + len(shape_a) for i in axes]
-        free = [i for i in xrange(len(shape_a)) if i not in axes]
+        free = [i for i in range(len(shape_a)) if i not in axes]
         axes_dims = [shape_a[i] for i in axes]
         free_dims = [shape_a[i] for i in free]
         free_dims_static = free_dims
@@ -4037,8 +4036,8 @@ def tensordot(a, b, axes, name=None):
         if axes > a_shape.ndims:
           raise ValueError("'axes' must not be larger than the number of "
                            "dimensions of tensor %s." % a)
-        return (list(xrange(a_shape.ndims - axes,
-                            a_shape.ndims)), list(xrange(axes)))
+        return (list(range(a_shape.ndims - axes,
+                            a_shape.ndims)), list(range(axes)))
       else:
         rank = array_ops.rank(a)
         return (range(rank - axes, rank,
diff --git a/tensorflow/python/ops/nn_batchnorm_test.py b/tensorflow/python/ops/nn_batchnorm_test.py
index 5f0616b384f..216b9c56ba4 100644
--- a/tensorflow/python/ops/nn_batchnorm_test.py
+++ b/tensorflow/python/ops/nn_batchnorm_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -360,7 +359,7 @@ class SufficientStatisticsTest(test.TestCase):
       m_ss = np.sum(x, axis=axis, keepdims=keep_dims)
       v_ss = np.sum(x * x, axis=axis, keepdims=keep_dims)
     count = 1.0
-    for d in xrange(x.ndim):
+    for d in range(x.ndim):
       if d in set(axes):
         count *= x.shape[d]
     if not keep_dims:
diff --git a/tensorflow/python/ops/nn_test.py b/tensorflow/python/ops/nn_test.py
index 8bd90f01ba1..1a8d0d4c555 100644
--- a/tensorflow/python/ops/nn_test.py
+++ b/tensorflow/python/ops/nn_test.py
@@ -22,7 +22,6 @@ import math
 
 from absl.testing import parameterized
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.eager import def_function
 from tensorflow.python.framework import constant_op
@@ -317,7 +316,7 @@ class DropoutTest(test_lib.TestCase):
       dropout = nn_ops.dropout(t, rate=(1 - keep_prob))
       final_count = 0
       self.assertEqual([x_dim, y_dim], dropout.get_shape())
-      for _ in xrange(0, num_iter):
+      for _ in range(0, num_iter):
         value = self.evaluate(dropout)
         final_count += np.count_nonzero(value)
         # Verifies that there are only two values: 0 and 1/keep_prob.
@@ -344,7 +343,7 @@ class DropoutTest(test_lib.TestCase):
       dropout = nn_ops.dropout(t, rate=(1 - keep_prob), noise_shape=[x_dim, 1])
       self.assertEqual([x_dim, y_dim], dropout.get_shape())
       final_count = 0
-      for _ in xrange(0, num_iter):
+      for _ in range(0, num_iter):
         value = self.evaluate(dropout)
         final_count += np.count_nonzero(value)
         # Verifies that there are only two values: 0 and 1/keep_prob.
@@ -367,10 +366,10 @@ class DropoutTest(test_lib.TestCase):
       t = constant_op.constant(1.0, shape=[x_dim, y_dim], dtype=dtypes.float32)
       dropout = nn_ops.dropout(t, rate=(1 - keep_prob), noise_shape=[x_dim, 1])
       self.assertEqual([x_dim, y_dim], dropout.get_shape())
-      for _ in xrange(0, num_iter):
+      for _ in range(0, num_iter):
         value = self.evaluate(dropout)
         # Verifies that each y column as only one type of activation.
-        for i in xrange(x_dim):
+        for i in range(x_dim):
           sorted_value = np.unique(np.sort(value[i, :]))
           self.assertEqual(sorted_value.size, 1)
 
@@ -390,7 +389,7 @@ class DropoutTest(test_lib.TestCase):
         dropout = nn_ops.dropout(t, keep_prob_placeholder)
         final_count = 0
         self.assertEqual([x_dim, y_dim], dropout.get_shape())
-        for _ in xrange(0, num_iter):
+        for _ in range(0, num_iter):
           value = dropout.eval(feed_dict={keep_prob_placeholder: keep_prob})
           final_count += np.count_nonzero(value)
           # Verifies that there are only two values: 0 and 1/keep_prob.
@@ -425,7 +424,7 @@ class DropoutTest(test_lib.TestCase):
       dropout = nn_ops.dropout(t, rate=(1 - keep_prob), noise_shape=[None, 1])
       self.assertEqual([x_dim, y_dim], dropout.get_shape())
       final_count = 0
-      for _ in xrange(0, num_iter):
+      for _ in range(0, num_iter):
         value = self.evaluate(dropout)
         final_count += np.count_nonzero(value)
         # Verifies that there are only two values: 0 and 1/keep_prob.
@@ -706,9 +705,9 @@ class ComputeSampledLogitsTest(test_lib.TestCase):
       # First we need to find the hits in this random test run:
       labels_reshape = labels.reshape((batch_size, num_true))
       got_logits = self.evaluate(logits_tensor)
-      for row in xrange(batch_size):
+      for row in range(batch_size):
         row_labels = labels_reshape[row, :]
-        for col in xrange(len(sampled)):
+        for col in range(len(sampled)):
           if sampled[col] in row_labels:
             # We need to add the num_true_test offset into logits_*
             self.assertNear(
diff --git a/tensorflow/python/ops/special_math_ops.py b/tensorflow/python/ops/special_math_ops.py
index 5f3b179d5d2..8c2c3e8a6b1 100644
--- a/tensorflow/python/ops/special_math_ops.py
+++ b/tensorflow/python/ops/special_math_ops.py
@@ -24,8 +24,6 @@ from __future__ import print_function
 import re
 import string
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
-
 from tensorflow.compiler.tf2xla.ops import gen_xla_ops
 from tensorflow.python.framework import ops
 from tensorflow.python.ops import array_ops
@@ -283,7 +281,7 @@ def einsum(equation, *inputs, **kwargs):
           input_axis_labels[1] + '->' + output_axis_labels)
     temp = inputs[0]
     temp_axis_labels = input_axis_labels[0]
-    for i in xrange(len(inputs) - 1):
+    for i in range(len(inputs) - 1):
       axes_to_sum = (
           set(temp_axis_labels) &
           set(input_axis_labels[i + 1]) - set(output_axis_labels))
diff --git a/tensorflow/python/ops/variable_scope.py b/tensorflow/python/ops/variable_scope.py
index 553052550d2..d26ce3374a1 100644
--- a/tensorflow/python/ops/variable_scope.py
+++ b/tensorflow/python/ops/variable_scope.py
@@ -28,7 +28,6 @@ import traceback
 
 import six
 from six import iteritems
-from six.moves import xrange, zip  # pylint: disable=redefined-builtin
 
 from tensorflow.python import tf2
 from tensorflow.python.eager import context
@@ -162,7 +161,7 @@ class _PartitionInfo(object):
                                                        self.full_shape,
                                                        len(self.full_shape)))
 
-    for i in xrange(len(shape)):
+    for i in range(len(shape)):
       if self.var_offset[i] + shape[i] > self.full_shape[i]:
         raise ValueError(
             "With self.var_offset={}, a partition of shape={} would exceed "
@@ -170,7 +169,7 @@ class _PartitionInfo(object):
                 self.var_offset, shape, self.full_shape, i))
 
     slice_dim = None
-    for i in xrange(len(shape)):
+    for i in range(len(shape)):
       if shape[i] == self.full_shape[i]:
         continue
       if slice_dim is not None:
@@ -2453,7 +2452,7 @@ def _iter_slices(full_shape, num_slices, slice_dim):
   num_slices_with_excess = full_shape[slice_dim] % num_slices
   offset = [0] * len(full_shape)
   min_slice_len = full_shape[slice_dim] // num_slices
-  for i in xrange(num_slices):
+  for i in range(num_slices):
     shape = full_shape[:]
     shape[slice_dim] = min_slice_len + bool(i < num_slices_with_excess)
     yield offset[:], shape
diff --git a/tensorflow/python/platform/tf_logging.py b/tensorflow/python/platform/tf_logging.py
index 86a4957c9da..8924334a5df 100644
--- a/tensorflow/python/platform/tf_logging.py
+++ b/tensorflow/python/platform/tf_logging.py
@@ -60,8 +60,8 @@ def _get_caller(offset=3):
 
 # The definition of `findCaller` changed in Python 3.2
 if _sys.version_info.major >= 3 and _sys.version_info.minor >= 2:
-  def _logger_find_caller(stack_info=False):  # pylint: disable=g-wrong-blank-lines
-    code, frame = _get_caller(4)
+  def _logger_find_caller(stack_info=False, stacklevel=1):  # pylint: disable=g-wrong-blank-lines
+    code, frame = _get_caller(3+stacklevel)
     sinfo = None
     if stack_info:
       sinfo = '\n'.join(_traceback.format_stack())
diff --git a/tensorflow/python/profiler/model_analyzer.py b/tensorflow/python/profiler/model_analyzer.py
index f3b521a6bfb..5b1e6e2f674 100644
--- a/tensorflow/python/profiler/model_analyzer.py
+++ b/tensorflow/python/profiler/model_analyzer.py
@@ -133,7 +133,7 @@ class Profiler(object):
     # Currently we are only allowed to create 1 profiler per process.
     profiler = Profiler(sess.graph)
 
-    for i in xrange(total_steps):
+    for i in range(total_steps):
       if i % 10000 == 0:
         run_meta = tf.compat.v1.RunMetadata()
         _ = sess.run(...,
diff --git a/tensorflow/python/summary/summary_test.py b/tensorflow/python/summary/summary_test.py
index 64f0f315c58..1df412b8ed9 100644
--- a/tensorflow/python/summary/summary_test.py
+++ b/tensorflow/python/summary/summary_test.py
@@ -23,7 +23,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import summary_pb2
 from tensorflow.python.framework import constant_op
@@ -105,7 +104,7 @@ class SummaryTest(test.TestCase):
     values = summary.value
     self.assertEqual(len(values), 3)
     tags = sorted(v.tag for v in values)
-    expected = sorted('outer/inner/image/{}'.format(i) for i in xrange(3))
+    expected = sorted('outer/inner/image/{}'.format(i) for i in range(3))
     self.assertEqual(tags, expected)
 
   @test_util.run_deprecated_v1
@@ -122,7 +121,7 @@ class SummaryTest(test.TestCase):
     self.assertEqual(len(values), 3)
     tags = sorted(v.tag for v in values)
     expected = sorted('family/outer/family/inner/image/{}'.format(i)
-                      for i in xrange(3))
+                      for i in range(3))
     self.assertEqual(tags, expected)
 
   @test_util.run_deprecated_v1
@@ -168,7 +167,7 @@ class SummaryTest(test.TestCase):
     values = summary.value
     self.assertEqual(len(values), 3)
     tags = sorted(v.tag for v in values)
-    expected = sorted('outer/inner/audio/{}'.format(i) for i in xrange(3))
+    expected = sorted('outer/inner/audio/{}'.format(i) for i in range(3))
     self.assertEqual(tags, expected)
 
   @test_util.run_deprecated_v1
@@ -185,7 +184,7 @@ class SummaryTest(test.TestCase):
     self.assertEqual(len(values), 3)
     tags = sorted(v.tag for v in values)
     expected = sorted('family/outer/family/inner/audio/{}'.format(i)
-                      for i in xrange(3))
+                      for i in range(3))
     self.assertEqual(tags, expected)
 
   @test_util.run_deprecated_v1
diff --git a/tensorflow/python/tpu/device_assignment.py b/tensorflow/python/tpu/device_assignment.py
index 863d5e61e69..580fbf48205 100644
--- a/tensorflow/python/tpu/device_assignment.py
+++ b/tensorflow/python/tpu/device_assignment.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import math
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.platform import tf_logging as logging
 from tensorflow.python.tpu.topology import Topology
@@ -33,8 +32,8 @@ SINGLE_CORE_ASSIGNMENT = [[[0, 0, 0]]]
 def _compute_task_and_cores_to_replicas(core_assignment, topology):
   """Computes a nested dict which maps task and logical core to replicas."""
   task_and_cores_to_replicas = {}
-  for replica in xrange(core_assignment.shape[0]):
-    for logical_core in xrange(core_assignment.shape[1]):
+  for replica in range(core_assignment.shape[0]):
+    for logical_core in range(core_assignment.shape[1]):
       coordinates = core_assignment[replica, logical_core, :]
       task_id = topology.task_ordinal_at_coordinates(coordinates)
       if task_id not in task_and_cores_to_replicas:
@@ -347,10 +346,10 @@ def device_assignment(topology,
     inner_ring = _ring_2d(computation_shape[0], computation_shape[1])
     outer_ring = _ring_2d(replica_shape[0], replica_shape[1])
 
-    for replica in xrange(num_replicas):
+    for replica in range(num_replicas):
       outer_x, outer_y = outer_ring[replica]
       per_replica_assignment = []
-      for index in xrange(np.prod(computation_shape)):
+      for index in range(np.prod(computation_shape)):
         inner_x, inner_y = inner_ring[index // 2]
         px = outer_x * computation_shape[0] + inner_x
         py = outer_y * computation_shape[1] + inner_y
@@ -358,7 +357,7 @@ def device_assignment(topology,
         per_replica_assignment.append([px, py, pz])
       assignment.append(per_replica_assignment)
   else:
-    for replica in xrange(num_replicas):
+    for replica in range(num_replicas):
       # Chooses a replica number in each axis.
       t = replica
       pos = []
@@ -375,7 +374,7 @@ def device_assignment(topology,
     # Computes a logical core -> physical core mapping for each replica.
     indices = [
         np.arange(0, computation_shape[i] * computation_stride[i],
-                  computation_stride[i]) for i in xrange(topology_rank)
+                  computation_stride[i]) for i in range(topology_rank)
     ]
     indices = np.concatenate(
         [i[..., np.newaxis] for i in np.meshgrid(*indices, indexing="ij")],
diff --git a/tensorflow/python/tpu/topology.py b/tensorflow/python/tpu/topology.py
index 00ee21e694d..ea5bb22a485 100644
--- a/tensorflow/python/tpu/topology.py
+++ b/tensorflow/python/tpu/topology.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf.tpu import topology_pb2
 
@@ -129,8 +128,8 @@ class Topology(object):
     """Inverts a [task,device,axis] topology to [x,y,z] -> task/device maps."""
     tasks = np.full(list(self.mesh_shape), -1, dtype=np.int32)
     devices = np.full(list(self.mesh_shape), -1, dtype=np.int32)
-    for task in xrange(self.device_coordinates.shape[0]):
-      for device in xrange(self.device_coordinates.shape[1]):
+    for task in range(self.device_coordinates.shape[0]):
+      for device in range(self.device_coordinates.shape[1]):
         x, y, z = self.device_coordinates[task, device, :]
         tasks[x, y, z] = task
         devices[x, y, z] = device
diff --git a/tensorflow/python/tpu/tpu.py b/tensorflow/python/tpu/tpu.py
index f65068b3f7f..e884c5c42a7 100644
--- a/tensorflow/python/tpu/tpu.py
+++ b/tensorflow/python/tpu/tpu.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 
 from absl import logging
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import attr_value_pb2
 from tensorflow.core.protobuf.tpu import dynamic_padding_pb2 as dynamic_padding
@@ -458,7 +457,7 @@ class TPUReplicateContext(control_flow_ops.XLAControlFlowContext):
         op._add_control_input(self.GetControlPivot())
         # pylint: enable=protected-access
     else:
-      for index in xrange(len(op.inputs)):
+      for index in range(len(op.inputs)):
         x = op.inputs[index]
         real_x = self.AddValue(x)
         if real_x is not x:
@@ -832,7 +831,7 @@ def split_compile_and_replicate(computation,
     return []
 
   # Checks all replicas have the same structure.
-  for i in xrange(1, num_replicas):
+  for i in range(1, num_replicas):
     nest.assert_same_structure(inputs[0], inputs[i])
 
   # Flatten inputs.
@@ -904,7 +903,7 @@ def split_compile_and_replicate(computation,
   # Fan-in: Builds a TPUReplicatedInput node for each input.
   flat_replicated_inputs = []
   for i in range(0, len(flat_inputs[0])):
-    replicas = [flat_inputs[replica][i] for replica in xrange(num_replicas)]
+    replicas = [flat_inputs[replica][i] for replica in range(num_replicas)]
     flat_replicated_inputs.append(
         tpu_ops.tpu_replicated_input(replicas, name="input{}".format(i)))
 
@@ -1043,7 +1042,7 @@ def split_compile_and_replicate(computation,
     ]
 
   # Fan-out: Builds a TPUReplicatedOutput node for each output.
-  replicated_outputs = [[] for i in xrange(num_replicas)]
+  replicated_outputs = [[] for i in range(num_replicas)]
   for i, t in enumerate(output_tensors):
     # Fan-out: Builds a TPUReplicatedOutput node for each output.
     ys = tpu_ops.tpu_replicated_output(
@@ -1052,7 +1051,7 @@ def split_compile_and_replicate(computation,
     # Wraps the outputs in identity operators so the names of any possible
     # `fetch` nodes are preserved by the replication rewrite.
     with ops.control_dependencies(control_deps):
-      for replica in xrange(num_replicas):
+      for replica in range(num_replicas):
         replicated_outputs[replica].append(
             array_ops.identity(
                 ys[replica], name="output_%d_shard_%d" % (i, replica)))
